'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.refinerReselector = exports.getRefiner = undefined;

var _reselect = require('reselect');

var _package = require('../package');

var getRefiner = exports.getRefiner = function getRefiner(_ref) {
  var collectionName = _ref.collectionName,
      isSingular = _ref.isSingular,
      getControlQuery = _ref.getControlQuery,
      query = _ref.query,
      schema = _ref.schema;

  var allReselector = (0, _package.createNormalizerAllReselector)(collectionName);
  var filterReselector = query && (0, _package.createNormalizerFilterReselector)(allReselector, query, { isSingular: isSingular });
  var controlReselector = getControlQuery && (0, _package.createNormalizerFilterReselector)(filterReselector || allReselector, getControlQuery, { isSingular: isSingular, schema: schema });
  return { allReselector: allReselector,
    filterReselector: filterReselector,
    controlReselector: controlReselector
  };
};

var refinerReselector = exports.refinerReselector = (0, _reselect.createSelector)(function (option) {
  return option;
}, getRefiner);