'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.mergedTestFaaIds = exports.mergedTestFooIds = exports.mergedTestFoosById = exports.mergedTestFoos = exports.mergedTestFaas = exports.description = undefined;

var _theFaasById;

exports.initTestReducer = initTestReducer;
exports.initTestRootReducer = initTestRootReducer;
exports.initTestStore = initTestStore;

var _lodash = require('lodash.keyby');

var _lodash2 = _interopRequireDefault(_lodash);

var _redux = require('redux');

var _lib = require('../lib');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var description = exports.description = {
  foos: {
    items: [{ key: 'faaId', type: 'String' }, { key: 'id', type: 'String', isAutomatic: true }, { key: 'myFaaId', type: 'String' }, { key: 'number', type: 'Number' }, { key: 'things', type: 'Array[String]' }, { key: 'theFaaIds', type: 'Array[String]' }, { key: 'txt', type: 'String' }, { key: 'yourFaaId', type: 'String' }],
    title: 'foo',
    type: 'collection'
  },
  faas: {
    items: [{ key: 'id', type: 'String', isAutomatic: true }, { key: 'txt', type: 'String' }],
    title: 'faa',
    type: 'collection'
  }
};

var mergedTestFaas = exports.mergedTestFaas = [{ id: '58d2a5818975fd0893fc8b6e', txt: 'molky is fun. A lot.' }, { id: '58d2a5818975fd0893fc8b6c', txt: 'Too packed for life' }, { id: '58d2a5818975fd0893fc8b6b', txt: 'Karl Marx Landers' }];

var mergedTestFoos = exports.mergedTestFoos = [{
  id: '58d2a5818975fd1893fc8b6a',
  number: 1,
  txt: 'hello',
  things: [0],
  // myFaaId: '58d2a5818975fd0893fc8b6e',
  myFaa: mergedTestFaas[0],
  // yourFaaId: '58d2a5818975fd0893fc8b6c',
  yourFaa: mergedTestFaas[1]
}, {
  id: '58d2a5818975fd2893fc8b6b',
  number: 35,
  txt: 'bonjour!',
  things: []
}, {
  id: '58d2a5818975fd3893fc8b6c',
  number: 43,
  txt: 'yo nigger',
  things: []
}, {
  id: '58d2a5818975fd4893fc8b7a',
  number: 1,
  txt: 'hello bis',
  things: [3],
  // faaId: '58d2a5818975fd0893fc8b6b',
  faa: mergedTestFaas[2],
  // theFaaIds: ['58d2a5818975fd0893fc8b6b', '58d2a5818975fd0893fc8b6e'],
  theFaasById: (_theFaasById = {}, _defineProperty(_theFaasById, mergedTestFaas[2].id, mergedTestFaas[2]), _defineProperty(_theFaasById, mergedTestFaas[1].id, mergedTestFaas[1]), _theFaasById)
}, {
  id: '58d2a5818975fd5893fc8b3b',
  number: 43,
  txt: 'yo nigger bis',
  things: [1]
}];

var mergedTestFoosById = exports.mergedTestFoosById = (0, _lodash2.default)(mergedTestFoos, 'id');
var mergedTestFooIds = exports.mergedTestFooIds = Object.keys(mergedTestFoosById).sort();
var mergedTestFaaIds = exports.mergedTestFaaIds = mergedTestFaas.map(function (mergedTestFaa) {
  return mergedTestFaa.id;
}).sort();

function initTestReducer() {
  var appSchema = (0, _lib.createAppSchema)(description);
  var normalizer = (0, _lib.createReducer)({ schema: appSchema });
  return { appSchema: appSchema, normalizer: normalizer };
}

function initTestRootReducer() {
  var _initTestReducer = initTestReducer(),
      appSchema = _initTestReducer.appSchema,
      normalizer = _initTestReducer.normalizer;

  var rootReducer = (0, _redux.combineReducers)({ normalizer: normalizer });
  return { appSchema: appSchema, normalizer: normalizer, rootReducer: rootReducer };
}

function initTestStore() {
  var _initTestRootReducer = initTestRootReducer(),
      appSchema = _initTestRootReducer.appSchema,
      normalizer = _initTestRootReducer.normalizer,
      rootReducer = _initTestRootReducer.rootReducer;

  var store = (0, _redux.createStore)(rootReducer);
  return { appSchema: appSchema, normalizer: normalizer, rootReducer: rootReducer, store: store };
}